# $Id:$
# $URL:$
from cgi import parse_qs
from cqlparser import parseString as parseCQL
from meresco.core import Observable
from urlparse import urlsplit
from httplib import HTTPConnection, OK
import urllib
import pprint
#pp = pprint.PrettyPrinter(indent=2)

class GetIdentifiers(Observable):
    def __init__(self, infra):
        Observable.__init__(self)
        self.infra = infra
        self.logger = infra.logging.getLogger('meresco.getidentifiers')
        self.logger.debug("starting logger")
        self.pp = pprint.PrettyPrinter(indent=2)

    def okText(self):
        CRLF = "\r\n"
        ContentType = "Content-Type: text/plain"
        okText = "HTTP/1.0 200 OK" + CRLF + \
                 ContentType + CRLF + \
                 CRLF
        return okText

    def handleRequest(self, RequestURI='', **kwargs):
        pp = self.pp
        self.logger.debug("kwargs: " + pp.pformat(kwargs))

        Scheme, Netloc, Path, Query, Fragment = urlsplit(RequestURI)
        arguments = parse_qs(Query)

        query =  arguments.get('query', [''])[0]
        cqlAbstractSyntaxTree = parseCQL(query)
        start = int(arguments.get('start', ['0'])[0])
        stop = int(arguments.get('stop', ['10'])[0])
        if stop - start > 1000: stop = start + 1000
        sortBy =  arguments.get('sortBy', [''])[0]
        sortDescending =  arguments.get('sortDescending', ['1'])[0]
        sortDescending = sortDescending == '1'
        identifierPrefix = arguments.get('prefix', ['yes'])[0]
        total, recordIds = self.any.executeCQL(cqlAbstractSyntaxTree=cqlAbstractSyntaxTree, start=start, stop=stop, sortBy=sortBy, sortDescending=sortDescending)
        yield self.okText()
        yield "# query=%s total=%s start=%s stop=%s prefix=%s\n" %(query, total, start, stop, identifierPrefix)
        for recordId in recordIds:
            if identifierPrefix == "no" or identifierPrefix == "No":
                recordId = recordId.split(":", 1)[1]
            yield recordId + "\n"
